Bug 47340

Summary: uldap_cache_comparedn() called without a lock
Product: Apache httpd-2 Reporter: Tammy <tammy000>
Component: AllAssignee: Apache HTTPD Bugs Mailing List <bugs>
Status: RESOLVED LATER    
Severity: normal CC: tammy000
Priority: P2 Keywords: MassUpdate
Version: 2.2.11   
Target Milestone: ---   
Hardware: All   
OS: All   

Description Tammy 2009-06-09 15:16:52 UTC
Per the block comment before the body of function uldap_cache_comparedn(), a lock must be held already:

/* ...
   The lock for the ldap cache should already be acquired */
static int uldap_cache_comparedn() ...)

But when it is called from authz_ldap_check_user_access(), no lock is held before calling uldap_cache_comparedn(). It is a bug, or the comment is outdated?


Detected by an automatic tool iComment.
Comment 1 Dan Poirier 2009-06-10 06:01:48 UTC
There only seems to be one cache lock, and this function acquires and releases it internally several times, so it certainly seems unnecessary for the lock to already be held before calling it.

I was hoping to find a revision in which this internal locking was added without removing that comment, but it appears to have been this way since before the file was added to subversion (http://svn.apache.org/viewvc?view=rev&revision=91504).

Still, I think the comment is wrong.
Comment 2 William A. Rowe Jr. 2018-11-07 21:09:26 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.